--- datastore_db.c.orig	2002-11-10 20:19:45.000000000 -0500
+++ datastore_db.c	2002-11-14 16:31:11.000000000 -0500
@@ -17,6 +17,7 @@
 #include <unistd.h>
 #include <db.h>
 #include <errno.h>
+#include <netinet/in.h>
 
 #include "config.h"
 #ifdef	HAVE_SYSLOG_H
@@ -126,6 +127,11 @@
     if (ret == 0) {
       value = *(long *)db_data.data;
 
+#if DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR > 0
+      if (!__db_isbigendian())	/* from db-4.1.24.NC/common/db_byteorder.c */
+	  value = ntohl(value);
+#endif
+
       if (DEBUG_DATABASE(2)) {
         fprintf(stderr, "[%lu] db_getvalue (%s): [%s] has value %ld\n",
 		(unsigned long) handle->pid, handle->name, word, value);
@@ -165,6 +171,11 @@
     key.data = t = xstrdup(word);
     key.size = strlen(word);
 
+#if DB_VERSION_MAJOR == 4 && DB_VERSION_MINOR > 0
+    if (!__db_isbigendian())	/* from db-4.1.24.NC/common/db_byteorder.c */
+	value = htonl(value);
+#endif
+
     data.data = &value;
     data.size = sizeof(long);
 
